datablock AudioProfile(R700FireSound)
{
   filename    = "./awp1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(R700BoltOutSound)
{
   filename    = "./R700_bolt_back.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(R700BoltInSound)
{
   filename    = "./R700_bolt_forward.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(RemmingtonSmokeParticle)
{
	dragCoefficient      = 3.5;
	gravityCoefficient   = -0.10;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.25";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.25;

	useInvAlpha = false;
};

datablock ParticleEmitterData(RemmingtonSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RemmingtonSmokeParticle";
};


//bullet trail effects
datablock ParticleData(RemmingtonbulletTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 625;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/thinRing";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.3 0.3 0.9 0.4";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.075;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RemmingtonbulletTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RemmingtonbulletTrailParticle";
};

AddDamageType("R700",   '<bitmap:Add-Ons/Weapon_Remmington700/CI_R700> %1',    '%2 <bitmap:Add-Ons/Weapon_Remmington700/CI_R700> %1',0.5,1);
AddDamageType("R700head",'<bitmap:Add-Ons/Weapon_Remmington700/CI_R700> (headshot) %1','%2 <bitmap:Add-Ons/Weapon_Remmington700/CI_R700> (headshot) %1',2,1);
datablock ProjectileData(RemmingtonProjectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::R700;
   radiusDamageType    = $DamageType::R700;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 25;
   brickExplosionMaxVolume = 200;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 200;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 750;
   verticalImpulse	  = 450;
   explosion           = GunExplosion;
   particleEmitter     = RemmingtonbulletTrailEmitter;

   muzzleVelocity      = 2000;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(RemmingtonItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Remmington700.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "R700";
	iconName = "./icon_Remmington700";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = RemmingtonImage;
	canDrop = true;
};


////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RemmingtonImage)
{
   // Basic Item properties
   shapeFile = "./Remmington700.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.0045 0.05 0.1";
   eyeOffset = "0.475 1.35 -1";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = RemmingtonProjectile;
   projectileType = Projectile;

	casing = GunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 1500;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   doColorShift = false;
   colorShiftColor = RemmingtonItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "BoltOut";
	stateTimeoutValue[2]            = 0.25;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= GunFlashEmitter;
	stateEmitterTime[2]				= 0.025;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= R700FireSound;

	stateName[3] = "BoltOut";
	stateTimeoutValue[3]            = 0.25;
	stateTransitionOnTimeout[3]     = "Smoke";
	stateWaitForTimeout[3]			= true;
	stateSequence[3]                = "BoltOut";
	stateSound[3]					= R700BoltOutSound;

	stateName[4] = "Smoke";
	stateEmitter[4]					= RemmingtonSmokeEmitter;
	stateEmitterTime[4]				= 0.75;
	stateEmitterNode[4]				= "muzzlePoint";
	stateTimeoutValue[4]            = 0.75;
	stateTransitionOnTimeout[4]     = "BoltIn";
	stateEjectShell[4]       = true;

	stateName[5] = "BoltIn";
	stateTimeoutValue[5]            = 0.25;
	stateTransitionOnTimeout[5]     = "Reload";
	stateWaitForTimeout[5]			= true;
	stateSequence[5]                = "BoltIn";
	stateSound[5]					= R700BoltInSound;

	stateName[6]			= "Reload";
	stateSequence[6]                = "Reload";
	stateTransitionOnTriggerUp[6]     = "Ready";
	//stateSequence[6]	= "Ready";

};

function RemmingtonImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
	Parent::onFire(%this,%obj,%slot);	
}

function RemmingtonProjectile::Damage(%this, %obj, %col, %fade, %pos, %normal)
{
   if(%col.getClassName() $="Player" || %col.getClassName() $= "AIPlayer") //If they're a player of some kind
   {
      if(%col.getClassName() $= "AIPlayer")
      {
         %oldClient = %col.client; //Just in case the bot already had a client
         %col.client = BotConnection;
         %hitBoxList = getHitbox(%obj, %col, %pos);
         %col.client = %oldClient;
      }
      else
      {
         %hitBoxList = getHitbox(%obj, %col, %pos);
      }
      if(strReplace(%hitBoxList, "headskin", "BAM") $= %hitBoxList)
      {
         parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
      }
      else
      {
         %obj.client.centerPrint("\c6Headshot!",3);
         %obj.client.play2D(rewardSound);
         %col.damage(%obj, %pos, (125 * getWord(%obj.getScale(),2)), $DamageType::R700head);
      }
   }
   else
   {
      parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
   }
}